customFieldsGetterGlobalData = {
  regBlocks: []
}

function custom1Function() {
  let fieldsData = {
    curr_sens_amp_mode: 'GD_CONFIG2.VREF_DIV',
    align_opn_loop_ilimit_src_slct: 'MOTOR_STARTUP2.OL_ILIMIT_CONFIG',
    align_opn_loop_ilimit_index: 'MOTOR_STARTUP2.OL_ILIMIT',
    ilimit_thr_index: 'FAULT_CONFIG1.ILIMIT'
  };

  return fetchFieldValues(fieldsData).then((value) => {
    return value.curr_sens_amp_mode + value.align_opn_loop_ilimit_src_slct;
  })
}

function fetchFieldValues(fieldsData) {
  let fieldsArrayData = [];
  let resultData = {};
  let keys = Object.keys(fieldsData)
  for (let key of keys) {
    let data = fieldsData[key];
    let result = {
      name: key,
      fieldData: undefined,      
      registerValue: undefined
    }
    for (let regBlock of customFieldsGetterGlobalData.regBlocks) {
      for (let register of regBlock.registers) {
        if (register.name === data.split('.')[0]) {
          for (let field of register.fields) {
            if (field.name === data.split('.')[1]) {
              result.fieldData = field;
            }
          }
        }
      }
    }
    fieldsArrayData.push(result);
  }

  var prom = Q.when(0);

  fieldsArrayData.forEach((fieldArrayData) => {
    prom = prom.then(function() {
      if (fieldArrayData.registerValue === undefined) {
        let param = {
          "addr": fieldArrayData.fieldData.parentRegister.addr,
          "name": fieldArrayData.fieldData.parentRegister.name,
          "size": 32
        }
        return customReadRegister(param).then(value => {
          fieldArrayData.registerValue = value;
          resultData[fieldArrayData.name] = getFieldValueFromRegisterValue(fieldArrayData.registerValue, fieldArrayData.fieldData.start, fieldArrayData.fieldData.stop);
          for (let arrayData of fieldsArrayData) {
            if (arrayData.fieldData.parentRegister.name === fieldArrayData.fieldData.parentRegister.name) {
              arrayData.registerValue = fieldArrayData.registerValue;
              resultData[arrayData.name] = getFieldValueFromRegisterValue(arrayData.registerValue, arrayData.fieldData.start, arrayData.fieldData.stop);
            }
          }
          return resultData;
        })
      }
      return resultData;
    })
  })
  return prom;
}

function getFieldValueFromRegisterValue(registerValue, startBit, stopBit) {
  let fieldBinaryValue = _hex2bin(registerValue, 32).split('').reverse().join('').slice(startBit, stopBit + 1)
    .split('').reverse().join().replace(/,/g, '');
  return parseInt(fieldBinaryValue, 2);
}

function customReadRegister(param) {
  return CustomCodec.prototype.readValue(param);
}

function _hex2bin(hex, length) {
  let zeroes = function () {
    let result = '';
    for (let i = 0; i < length; i++) {
      result += '0';
    }
    return result;
  }();
  return (zeroes + (parseInt(hex, 16)).toString(2)).substr(-length);
}

function readCustomField(customFunction) {
  let deferred = Q.defer();
  window[customFunction]().then((value) => {
    deferred.resolve(value);
  })
  return deferred.promise;
}